// CColor.cpp
// by Comanche

#include "CColor.h"
#include "CMain.h"
#include "CLog.h"
#include "CGraphics.h"

extern CMain GameMain;
extern CLog Log;
extern CGraphics Graphics;

//////////////////////////////////////////////////////////////////////////////////

CColor::CColor()
{
	redpos=100;
	greenpos=100;
	bluepos=100;
}

//////////////////////////////////////////////////////////////////////////////////

void CColor::DrawColors()
{
	Graphics.Lock();
	Graphics.Quader(2,72,32,143,100,100,100);
	Graphics.Quader(35,72,65,143,100,100,100);
	Graphics.Quader(68,72,98,143,100,100,100);
	for(int i=0;i<=6;i++)
	{	
		Graphics.FullQuader(3,72+(i*10),31,82+(i*10),redpos+i,0,0);
		Graphics.FullQuader(36,72+(i*10),64,82+(i*10),0,greenpos+i,0);
		Graphics.FullQuader(69,72+(i*10),97,82+(i*10),0,0,bluepos+i);
	}
	Graphics.Quader(3,168,97,208,0,0,0);
	Graphics.FullQuader(4,169,96,207,color.rgbtRed,color.rgbtGreen,color.rgbtBlue);
	Graphics.UnLock();
}

//////////////////////////////////////////////////////////////////////////////////

void CColor::TestIfPressed()
{
	Graphics.Lock();

	if(GameMain.MouseX>=3 && GameMain.MouseX<=32 &&
	   GameMain.MouseY>=72 && GameMain.MouseY<=142 && GameMain.MouseB[0])
	{
		int y=GameMain.MouseY-72;
		color.rgbtRed=redpos+(y/10);
		Graphics.FullQuader(4,169,96,207,color.rgbtRed,color.rgbtGreen,color.rgbtBlue);		
	}

	if(GameMain.MouseX>=36 && GameMain.MouseX<=64 &&
	   GameMain.MouseY>=72 && GameMain.MouseY<=142 && GameMain.MouseB[0])
	{
		int y=GameMain.MouseY-72;
		color.rgbtGreen=greenpos+(y/10);
		Graphics.FullQuader(4,169,96,207,color.rgbtRed,color.rgbtGreen,color.rgbtBlue);
	}

	if(GameMain.MouseX>=69 && GameMain.MouseX<=97 &&
	   GameMain.MouseY>=72 && GameMain.MouseY<=142 && GameMain.MouseB[0])
	{
		int y=GameMain.MouseY-72;
		color.rgbtBlue=bluepos+(y/10);
		Graphics.FullQuader(4,169,96,207,color.rgbtRed,color.rgbtGreen,color.rgbtBlue);		
	}

	Graphics.UnLock();
}