// CGraphics.h
// by Comanche

#include "defines.h"

#ifndef CGRAPHICS
#define CGRAPHICS

//////////////////////////////////////////////////////////////////////////////////

extern BYTE *video_buffer;
extern int	WordsPerLine;

class CGraphics
{
public:
	void Init();
	void Lock();
	void UnLock();
	void LockBackBuffer();
	void UnLockBackBuffer();
	void Flip();
	void BltToBackBuffer();
	void GetDC();
	void GetLaDC();
	void ReleaseDC();
	void OSGetDC();
	void OSGetLaDC();
	void OSReleaseDC();
	void RestorePrimarySurface();
	void RestoreOffScreenSurface();
	BOOL StoreScreenArea(int x,int y,int x2,int y2);
	BOOL RestoreScreenArea();
	void Blt(int x,int y,int x2,int y2,int vx, int vy);
	void Text(int x,int y,char *string);
	void PutPixel(int x,int y,BYTE red,BYTE green,BYTE blue);
	void PutSafePixel(int x,int y,BYTE red,BYTE green,BYTE blue);
	void Quader(int x,int y,int x2,int y2, 
				  BYTE red,BYTE green,BYTE blue);
	void FullQuader(int x,int y,int x2,int y2, 
					   BYTE red,BYTE green,BYTE blue);
	void BlackQuader(int x,int y,int x2,int y2);
	void PutTransPixel(int x,int y,BYTE red, BYTE green,BYTE blue);
	void FullTransQuader(int x,int y,int x2,int y2,
						     BYTE red,BYTE green,BYTE blue);
	void FullBrightQuader(int x,int y,int x2,int y2,
							BYTE red,BYTE green,BYTE blue);
	void Line(int x,int y,int x2, int y2,BYTE red,BYTE green,BYTE blue);
	void HLine(int x,int y,int p,BYTE red,BYTE green,BYTE blue);
	void VLine(int x,int y,int p,BYTE red,BYTE green,BYTE blue);
	void TransHLine(int x,int y,int p,BYTE red,BYTE green,BYTE blue);
	void TransVLine(int x,int y,int p,BYTE red,BYTE green,BYTE blue);
	void DrawButton(int x,int y,int x2,int y2);
	void DrawPushedButton(int x,int y,int x2,int y2);
	void DrawCheckBoxOff(int x,int y);
	void DrawCheckBoxOn(int x,int y);
	HDC		xdc;
	LOGFONT logfont;
	RGBTRIPLE textcolor;
	BOOL DrawFont;
private:
	char	buffer[80];
	int		FrameTime;
	HFONT	Arial;
	int Sx,Sy,Sx2,Sy2;
	LPDIRECTDRAWSURFACE  lpddsos2;
};

#endif